console.log("Start initializing EN for CE");
EN.setup({
    'note': {
        'title': ${noteTitle},
        'source': ${noteSource},
        'sourceURL': ${noteSourceURL},
        'sourceApplication': ${noteSourceApplication},
        'contentClass': ${noteContentClass},
        'guid': ${noteGuid},
        'newNote': ${newNote},
        'notebookGUID': ${notebookGuid}
    },
    'rte': {
        'smartEditMode': true,
        'smartEnd': true,
        'smartEndSelector': 'div.en-note-container',
        'trackStateChanges': ${trackStateChanges},
        'trackValueChanges': ${trackValueChanges},
        'trackEnabledChanges': ${trackEnabledChanges},
        'imageConfig': {
            'imageClickEvents': true,
        },
        'typebehind': {
            'url': true,
            'email': true,
            'phone': ${phoneNumber},
            'horizontalrule': true,
            'list': true,
            'todo': true,
        },
        'smartScroll': true,
        'smartHeight': true,
        'resources': {},
        'mutationObserver': ${mutationObserver},
        'cryptLegacy': false,
        'cryptReadOnly': false,
        'locale': ${locale},
        'richLinks': ${richlinkEnabled},
        'richLinkCaching': ${richlinkEnabled},
        //'smartDelete': true,
    },
    'templates': {
        'enabled': ${templatesEnabled},
        'url': ${templatesUrl}
      },

    // https://www.evernote.com/shard/s12/sh/61fee335-35d8-4eb2-8a11-726ab653049b/430c8d2dd1364ae5
    'enabledApps': [ 'ce', 'templatemanager' ],
    'lockDefaultApp': true,
    'defaultApp': ${defaultApp},
    'platform': {
        'confirmAlert': '1',
        'optionsPopup': '1',
        'formDialog': '1',
        'actionNotification': '1'
      },

    'user': {
        'shardID': ${userShardId},
        'displayName': ${userDisplayName},
        'userID': ${userId},
        'authToken': ${userAuthToken},
        'serviceHost': ${userServiceHost},
        'accountType': ${userAccountType}
      },
    'keyboard': {
        'shortcuts': true,
        'editing': true,
    },
    'find': {},
    'accentuate': {
        'clearOnClickSelector': ''
    },
    'clipboard': {
        'intercept': true
    },
    'stayInEditMode': false,
    'debug': ${ceDebug},
    'darkmode': ${darkMode},
    'implicitBackspace': true
});

function handleResize() {
    noteEditor.onWebViewResized();
}
window.addEventListener("resize", handleResize);

EN.setupCopyHandler();

noteEditor.setVersion(EN.getVersion());

console.log("Done initializing EN");

