/**
 * Copyright 2014 Evernote Corporation. All rights reserved.
 */
function clipperInit() {
  "use strict";

  console.log("clipperInit()");

  console.log("clipperInit() - Browser exists?" + !(typeof window.Browser === 'undefined'));
  console.log("clipperInit() - SAFARI exists?" + !(typeof SAFARI === 'undefined'));
  console.log("clipperInit() - handleResourceResponse exists?" + (typeof(Browser.handleResourceResponse) == typeof(Function)));
  console.log("clipperInit() - sendToExtension exists?" + (typeof(Browser.sendToExtension) == typeof(Function)));

  var count = 0;
  var interval = setInterval(function() {
    if((document && window.jQueryClearly && document.readyState === 'complete') || count > 100) {
      clearInterval(interval);
      clipperStart();
    } else {
      console.log('waiting for preconditions ' + window.jQueryClearly + ' ' + document.readyState);
      count++;
    }
  }, 100);
}

function clipperStart() {
  console.log("clipperStart()");
  try {
    var x = document.createElement("div");
    x.id = "cssRulesCheckDiv";

    var y = document.createElement("style");
    y.innerText = "div#cssRulesCheckDiv {display:none}";

    document.body.appendChild(x);
    document.body.appendChild(y);

    console.log("startInternal - after adding test tags to body");

    window.startArticleTime = new Date().getTime();

    window.evernotePageInfo = new PageInfo();
    console.log("after initializing PageInfo=" + window.evernotePageInfo);

    if (!window.jQueryClearly) {
      console.log("No jQuery!");
      throw new Error("No jQuery!");
    }
    window.jQueryForClearlyComponent = window.jQueryClearly;

    console.log("after jquery check=" + window.jQueryForClearlyComponent);
    console.log("calling getDefaultArticle in init.js");

    evernotePageInfo.getDefaultArticle(function() {
      window.articleDetectionTime = (new Date().getTime()) - startArticleTime;
      console.log("done finding article " + articleDetectionTime + "ms ====================");
      Browser.articleReady(document.URL);
    });
  } catch (e) {
    for (var i in e) console.log(i + ": " + e[i]);
    console.log(e);
    JSClipInterface.clipFailed();
  }
}

clipperInit();
